# XMPP Client #

In order to reach the devices that are connected behind NAT, the cwmp protocol introduces alternative method of executing Connection Request via NAT based on XMPP. The xmppc is an implementation of XMPP functionality that performs this feature.

## Configuration File ##

The xmppc UCI configuration is located in **'/etc/config/xmpp'**, and contains 3 sections: **xmpp**, **xmpp\_connection** and **xmpp\_connection\_server**.

```bash
config xmpp 'xmpp'
	option enable '0'
	option id '0'
	option allowed_jid ''
	option loglevel '3'

config connection
	option enable '0'
	option username ''
	option password ''
	option domain 	''
	option resource ''
	option serveralgorithm 'DNS-SRV'
	
config connection_server
	option con_id '1'
	option enable '0'
	option port '5222'
```

For more info on the `xmppc` UCI configuration see [link](./docs/api/uci.xmpp.md)

## Dependencies ##

To successfully build xmpp, the following libraries are needed:

| Dependency  | Link                                    | License        |
| ----------- | --------------------------------------- | -------------- |
| libuci      | https://git.openwrt.org/project/uci.git | LGPL 2.1       |
| libstrophe  | https://github.com/strophe/libstrophe   | GPL 3.0        |

